/*
** GUI Header
*/

#include <sys/types.h>

#include "include/napster.h"

#ifndef AMSTER_GUI_H
#define AMSTER_GUI_H

extern struct guidata *gui;
extern enum OnlineState gui_onlinestate;
extern int UseLamps;	/* search.c needs this */
extern int UseTWF;		/* search.c needs this */

enum OnlineState {
	DISCONNECTED,
	OFFLINE,
	CONNECTING,
	LOGGING_IN,
	ONLINE
};

struct guidata {
	struct MUI_CustomClass *url_mcc;
	struct MUI_CustomClass *panel_mcc;
	struct MUI_CustomClass *search_mcc;
	struct MUI_CustomClass *resultview_mcc;
	struct MUI_CustomClass *dl_mcc;
	struct MUI_CustomClass *ul_mcc;
	struct MUI_CustomClass *share_mcc;
	struct MUI_CustomClass *prf_mcc;
	struct MUI_CustomClass *about_mcc;
	struct MUI_CustomClass *info_mcc;
	struct MUI_CustomClass *msg_mcc;
	struct MUI_CustomClass *chat_mcc;
	struct MUI_CustomClass *chatline_mcc;
	struct MUI_CustomClass *navi_mcc;
	struct MUI_CustomClass *hotlist_mcc;
	struct MUI_CustomClass *channellist_mcc;
	u_long *app;
	u_long *iconpanelmenu;
	u_long *win;
	u_long *maingrp, *searchpanel, *statgrp, *stat, *lamp, *inbut, *outbut, *rebut, *rect, *iconpanel;
	u_long *swin;
	u_long *shwin;
	u_long *iwin;
	u_long *mwin;
	u_long *dwin;
	u_long *uwin;
	u_long *awin;
	u_long *WI_Navigator, *WI_ConnectTo;
	u_long *WI_Hotlist;
	u_long *WI_ChannelList;

	/* Connect to... */
	u_long *ST_ConnectServer, *ST_ConnectPort, *ST_ConnectUser, *ST_ConnectPw, *TG_ConnectReg;
	u_long *BT_ConnectServer;

	/* Stat variables */
	int Songs, Libraries, Gigabytes;
	u_long OnlineSince;

	/* For now, let these variables live among the GUI instance data */
	char *ConnectUser, *ConnectPw;
};

enum {
	CONNECT,
	DISCONNECT,
	RECONNECT,
	CONNECTSERVER,
	EXECUTEAREXX,
	UPDATEPANEL,
	DEICONIFIED
};

#endif	/* AMSTER_GUI_H */
