/*
** Hotlist header
*/

#ifndef AMSTER_HOTLIST_H
#define AMSTER_HOTLIST_H

#include "include/mui.h"

#define HOTLIST_LOAD           0x2001
#define HOTLIST_SAVE	       0x2002
#define HOTLIST_UPLOAD         0x2003
#define HOTLIST_SIGNON         0x2004
#define HOTLIST_SIGNOFF        0x2005
#define HOTLIST_REMOVE         0x2006
#define HOTLIST_BROWSE         0x2007
#define HOTLIST_FOUND          0x2008
#define HOTLIST_NICK           0x2009
#define HOTLIST_CLEAR          0x2010
#define HOTLIST_TOGGLE         0x2011
#define HOTLIST_TOGGLE_RESULTS 0x2012
#define HOTLIST_SIGNOFF_ALL    0x2013
#define HOTLIST_ADD            0x2014

/* Class instance data */

struct HotlistData {
	u_long *LV_Hotlist, *LV_Search, *TG_Results, *ST_Nick;
};

struct HotlistEntry {
	char *Nick;
	int Speed;
	int Online;
};

/* Public prototypes */

extern MUIF HotlistDispatch(REG(a0) struct IClass *cl, REG(a2) Object *obj, REG(a1) Msg msg);
extern ULONG HotlistNew(struct IClass *cl, Object *obj, struct opSet *msg);
extern void HotlistInterpret(u_int com, char *data);

/* Public variables */

extern BOOL HotlistChanged;


#endif	/* AMSTER_HOTLIST_H */
