/*
** Preferences Header
*/

#include <sys/types.h>

#include "include/mui.h"

#ifndef AMSTER_PREFS_H
#define AMSTER_PREFS_H

extern struct prefsdata *prf;
extern struct MUI_CustomClass *QueueClass;

enum Event {
	PRFE_STARTUP,
	PRFE_EXIT,
	PRFE_CONNECT,
	PRFE_DISCONNECT,
	PRFE_DLSTART,
	PRFE_DLFINISH,
	PRFE_DLERROR,
	PRFE_DLABORT,
	PRFE_ULSTART,
	PRFE_ULFINISH,
	PRFE_ULERROR,
	PRFE_ULABORT,
	PRFE_INMSG,
	PRFE_LIB_DCLICK,
	PRFE_DL_DCLICK,
	PRFE_PLAYMP3,
	PRFE_END
};

struct prefsdata {
	/* User */
	char *user;
	char *pass;
	char *dlpath;
	char *email;
	int link;
	int BypassRegistration;
	int regflag;
	/* Options */
	int clrlist;
	int fullpath;
	int autocon;
	int askfile;
	int autoadd;
	int autosave;
	int AutoCleanup;
	int NameLength;
	/* Events */
	char *scripts[PRFE_END];
	char *sounds[PRFE_END];
	/* Advanced */
	char *napvers;
	char *MetaServer, *LeafServer;
	unsigned short MetaPort, LeafPort;
	unsigned short port;
	int DownloadQueueLimit;
	int DownloadTaskPri;
	int UploadQueueLimit;
	int UploadTaskPri;
	int QueueRetries;
	int QueueDelay;
	/* Startup */
	int noiconpanel;
	int lamps;
	int ServerList;
	/* Search */
	int speedqual, speedval;
	int bitratequal, bitrateval;
	int freqqual, freqval;
	int max;
};


struct prfdata {
	u_long *UserString, *PasswordString, *EMailString, *TG_BypassReg, *DownloadPathString, *LinkSpeedCycle;
	u_long *ClearListToggle, *AutoConnectToggle, *AskFileToggle, *AutoAddToggle, *AutoSaveToggle, *CM_ServerList;
	u_long *CY_ServerList, *CY_AutoCleanup, *LampCycle, *ST_NameLength;
	u_long *EventList, *EventScriptString, *EventSoundString;
	u_long *MetaServerString, *ST_MetaPort, *ServerString, *ST_LeafPort, *PortString, *FirewallToggle;
	u_long *DownloadQueueSlider, *UploadQueueSlider;
	u_long *DownloadPriSlider, *UploadPriSlider;
	u_long *ST_QueueRetries, *ST_QueueDelay;
/*	u_long *VersionString;*/
	int lastitem;
};

struct QueueData
{
	char buf[21];
};

MUIF prf_dispatch(REG(a0) struct IClass *cl,REG(a2) Object *obj,REG(a1) Msg msg);

#define PRF_OPEN       0x2001
#define PRF_CANCEL     0x2002
#define PRF_USE        0x2003
#define PRF_SAVE       0x2004
#define PRF_UPDATE     0x2005
#define PRF_SAVEALL    0x2006
#define PRF_TESTSND    0x2007
#define PRF_ENTRY      0x2009
#define PRF_LASTSAVED  0x2010
#define PRF_VALIDDELAY 0x2011

extern BOOL prf_load(char *fname);
extern void prf_save(char *fname);
extern void prf_setup(int argc, char *argv[]);
extern void prf_event(enum Event no, ...);

#define PRF_DEFAULT_PORT 6699


#endif	/* AMSTER_PREFS_H */
